<!---

    Slatwall - An Open Source eCommerce Platform
    Copyright (C) ten24, LLC

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Linking this program statically or dynamically with other modules is
    making a combined work based on this program.  Thus, the terms and
    conditions of the GNU General Public License cover the whole
    combination.

    As a special exception, the copyright holders of this program give you
    permission to combine this program with independent modules and your
    custom code, regardless of the license terms of these independent
    modules, and to copy and distribute the resulting program under terms
    of your choice, provided that you follow these specific guidelines:

	- You also meet the terms and conditions of the license of each
	  independent module
	- You must not alter the default display of the Slatwall name or logo from
	  any part of the application
	- Your custom code must not alter or create any files inside Slatwall,
	  except in the following directories:
		/integrationServices/

	You may copy and distribute the modified version of this program that meets
	the above guidelines as a combined work under the terms of GPL for this program,
	provided that you include the source code of that other code when and as the
	GNU GPL requires distribution of source code.

    If you modify this program, you may extend this exception to your version
    of the program, but you are not obligated to do so.

Notes:

--->

<!DOCTYPE html>
<html lang="en">
	<head>
	    <meta charset="utf-8">
	    <title>Slatwall</title>
		<meta name="viewport" content="width=device-width, initial-scale=1.0">

		<!--- jQuery is only required if you would like to use the Slatwall client side object --->
		<script src="//ajax.googleapis.com/ajax/libs/jquery/1.8.3/jquery.min.js"></script>

		<!--- This creates a client side object for Slatwall so that $.slatwall API works from the client side --->
		<cfoutput>#$.slatwall.renderJSObject( subsystem="public" )#</cfoutput>

		<!--- Bootstrap is just included for demo / example purposes.  Removing it will not stop Slatwall from working --->
		<link href="//netdna.bootstrapcdn.com/twitter-bootstrap/2.2.2/css/bootstrap-combined.min.css" rel="stylesheet">
		<script src="//netdna.bootstrapcdn.com/twitter-bootstrap/2.2.2/js/bootstrap.min.js"></script>
	</head>
	<body>
		<!--- This is only used by the sample app that is contained in /meta/sample --->
		<cfif structKeyExists(request, "sampleNavigation")>
			<cfoutput>#request.sampleNavigation#</cfoutput>
		</cfif>
		
		<!--- We can display basic user data even if the user is not logged in if they have previously logged in. This only works for non-admin users. --->
		<cfoutput>
			<div class="container">
			<cfif !$.slatwall.getLoggedInFlag()>
				<span style="color:black;font-size:13px">
					<cfif !isNull($.slatwall.getAccount().getFullName())> Hello <a href="/meta/sample/account.cfm">#$.slatwall.getAccount().getFullName()# </a></cfif>
					<span style="color:grey;font-size:14px">
						<cfif !isNull($.slatwall.getAccount().getCompany())> <small>#$.slatwall.getAccount().getCompany()#</small>&nbsp</cfif>
					</span>
					<span style="color:black;font-size:13px">
						<cfif !isnUll($.slatwall.getSession().getLoggedInDateTime())><small><b>(last seen: #$.slatwall.getSession().getLoggedInDateTime()#)</b></small> &nbsp</cfif><br>
					</span>
				</span><br>
			</cfif>
			<hr>
			</div>
		</cfoutput>